"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Just = /** @class */ (function () {
    function Just(_value) {
        this._value = _value;
        this._tag = 'Just';
    }
    return Just;
}());
var Nothing = /** @class */ (function () {
    function Nothing() {
        this._tag = 'Nothing';
    }
    return Nothing;
}());
exports.just = function (value) {
    return new Just(value);
};
exports.nothing = function () {
    return new Nothing();
};
exports.isJust = function (value) {
    return value instanceof Just;
};
exports.isNothing = function (value) {
    return value instanceof Nothing || value === null || value === undefined;
};
exports.withDefault = function (value, defaultValue) {
    switch (exports.isNothing(value)) {
        case false:
            return value._value;
        case true:
            return defaultValue;
    }
};
exports.map = function (f, value) {
    switch (exports.isNothing(value)) {
        case false:
            return exports.just(f(value._value));
        case true:
            return exports.nothing();
    }
};
exports.map2 = function (f, a, b) {
    switch (exports.isNothing(a) || exports.isNothing(b)) {
        case true:
            return exports.nothing();
        case false:
            return exports.just(f(a._value, b._value));
    }
};
exports.map3 = function (f, a, b, c) {
    switch (exports.isNothing(a) || exports.isNothing(b) || exports.isNothing(c)) {
        case true:
            return exports.nothing();
        case false:
            return exports.just(f(a._value, b._value, c._value));
    }
};
exports.map4 = function (f, a, b, c, d) {
    switch (exports.isNothing(a) || exports.isNothing(b) || exports.isNothing(c) || exports.isNothing(d)) {
        case true:
            return exports.nothing();
        case false:
            return exports.just(f(a._value, b._value, c._value, d._value));
    }
};
exports.map5 = function (f, a, b, c, d, e) {
    switch (exports.isNothing(a) ||
        exports.isNothing(b) ||
        exports.isNothing(c) ||
        exports.isNothing(d) ||
        exports.isNothing(e)) {
        case true:
            return exports.nothing();
        case false:
            return exports.just(f(a._value, b._value, c._value, d._value, e._value));
    }
};
exports.mapN = function (f) {
    var a = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        a[_i - 1] = arguments[_i];
    }
    switch (a.some(exports.isNothing)) {
        case true:
            return exports.nothing();
        case false:
            return exports.just(f.apply(void 0, a.map(function (v) { return v._value; })));
    }
};
exports.andThen = function (f, v) {
    switch (exports.isNothing(v)) {
        case true:
            return exports.nothing();
        case false:
            return f(v._value);
    }
};
exports.caseOf = function (caseof, value) {
    switch (exports.isNothing(value)) {
        case true:
            return caseof.Nothing();
        case false:
            return caseof.Just(value._value);
    }
};
